/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the ResetSecretResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ResetSecretResponse{}

// ResetSecretResponse struct for ResetSecretResponse
type ResetSecretResponse struct {
	APISecret *string `json:"API-secret,omitempty"`
}

// NewResetSecretResponse instantiates a new ResetSecretResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewResetSecretResponse() *ResetSecretResponse {
	this := ResetSecretResponse{}
	return &this
}

// NewResetSecretResponseWithDefaults instantiates a new ResetSecretResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewResetSecretResponseWithDefaults() *ResetSecretResponse {
	this := ResetSecretResponse{}
	return &this
}

// GetAPISecret returns the APISecret field value if set, zero value otherwise.
func (o *ResetSecretResponse) GetAPISecret() string {
	if o == nil || IsNil(o.APISecret) {
		var ret string
		return ret
	}
	return *o.APISecret
}

// GetAPISecretOk returns a tuple with the APISecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ResetSecretResponse) GetAPISecretOk() (*string, bool) {
	if o == nil || IsNil(o.APISecret) {
		return nil, false
	}
	return o.APISecret, true
}

// HasAPISecret returns a boolean if a field has been set.
func (o *ResetSecretResponse) HasAPISecret() bool {
	if o != nil && !IsNil(o.APISecret) {
		return true
	}

	return false
}

// SetAPISecret gets a reference to the given string and assigns it to the APISecret field.
func (o *ResetSecretResponse) SetAPISecret(v string) {
	o.APISecret = &v
}

func (o ResetSecretResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ResetSecretResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.APISecret) {
		toSerialize["API-secret"] = o.APISecret
	}
	return toSerialize, nil
}

type NullableResetSecretResponse struct {
	value *ResetSecretResponse
	isSet bool
}

func (v NullableResetSecretResponse) Get() *ResetSecretResponse {
	return v.value
}

func (v *NullableResetSecretResponse) Set(val *ResetSecretResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableResetSecretResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableResetSecretResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableResetSecretResponse(val *ResetSecretResponse) *NullableResetSecretResponse {
	return &NullableResetSecretResponse{value: val, isSet: true}
}

func (v NullableResetSecretResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableResetSecretResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


